typedef struct
{
	char *filename;

	char ignore;	/* for when a file is no longer tailable */

	int fd;		/* fd of file or -1 if none */
	int dir_fd;	/* fd for the directory the file is in */

	char retry_open;
	char follow_mode;

	dev_t	d;	/* used for determing if the file got a new name */
	ino_t	i;
	off64_t	st_size;

#ifdef USE_DNOTIFY
	int signr;	/* the signal we should be looking for */
#endif
#ifdef USE_FAM
	FAMRequest fr;
#endif
}
file;

#ifdef USE_DNOTIFY
#define SLEEP_INTERVAL	86400000
#else
#define SLEEP_INTERVAL  1000
#endif

#define INITIAL_N_LINES	10

#define BUFFER_SIZE	16384

#define FM_ONESHOT	1
#define FM_FILENAME	2
#define FM_DESCRIPTOR	3

#define IM_LINES	1
#define IM_BYTES	2

#define ID_END		0
#define ID_START	1

#define QM_ALWAYS	-1
#define QM_OTHERFILE	0
#define QM_QUIET	1

/* this code (the enum and the long_options array
 * was directly taken from GNU tail
 */
enum
{
	RETRY_OPTION = CHAR_MAX + 1,
	MAX_UNCHANGED_STATS_OPTION,
	MAX_CONSECUTIVE_SIZE_CHANGES_OPTION,
	PID_OPTION,
	LONG_FOLLOW_OPTION
};
struct option const long_options[] =
{
	{"allow-missing",	no_argument,		NULL,	RETRY_OPTION},
	{"bytes",		required_argument,	NULL,	'c'},
	{"follow",		optional_argument,	NULL,	LONG_FOLLOW_OPTION},
	{"lines",		required_argument,	NULL,	'n'},
	{"max-unchanged-stats",	required_argument,	NULL,	MAX_UNCHANGED_STATS_OPTION},
	{"max-consecutive-size-changes", required_argument, NULL,	MAX_CONSECUTIVE_SIZE_CHANGES_OPTION},
	{"pid",			required_argument,	NULL,	PID_OPTION},
	{"quiet",		no_argument,		NULL,	'q'},
	{"retry",		no_argument,		NULL,	RETRY_OPTION},
	{"silent",		no_argument,		NULL,	'q'},
	{"sleep-interval",	required_argument,	NULL,	's'},
	{"verbose",		no_argument,		NULL,	'v'},
	{"help",		no_argument,		NULL,	'h'},
	{"version",		no_argument,		NULL,	'V'},
	{NULL, 0, NULL, 0}
};
